//IFunctions.h
DEFINE_GUID(CLSID_CA,0x20000000,0x0000,0x0000,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x04);
DEFINE_GUID(IID_I_X,0x20000000,0x0000,0x0000,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x05);
DEFINE_GUID(IID_I_Y,0x20000000,0x0000,0x0000,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x06);

interface I_X : IUnknown                  //In C++ lingo an interface declaration such as this is known
{                                         //as an abstract base class.  It can't be instantiated directly
 virtual HRESULT __stdcall Fx1(int)=0;    //because it only contains what are known as pure virtual
 virtual HRESULT __stdcall Fx2(int)=0;    //functions (note the '=0' part).  What is actually going on   
};                                        //here is the creation of a specific footprint in memory that
 


interface I_Y : IUnknown                  //COM uses as its fundamental basis of operation.  Let me
{                                         //elaborate.  The C++ language was created long before COM and 
 virtual HRESULT __stdcall Fy1(int)=0;    //most implementations of the language allocate a pointer 
 virtual HRESULT __stdcall Fy2(int)=0;    //within a class for each abstract base class from which it
};                                        //inherits.  If you look just below and left you'll see that class
//End Ifunctions.h                        //CA inherits publically from interfaces I_X and I_Y.  In C++



/*
//IFunctions.h
DEFINE_GUID(CLSID_CA,0x20000000,0x0000,0x0000,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x04);
DEFINE_GUID(IID_I_X,0x20000000,0x0000,0x0000,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x05);
DEFINE_GUID(IID_I_Y,0x20000000,0x0000,0x0000,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x06);

interface I_X : IUnknown
{
 virtual HRESULT __stdcall Fx1(int)=0;
 virtual HRESULT __stdcall Fx2(int)=0;
};


interface I_Y : IUnknown
{
 virtual HRESULT __stdcall Fy1(int)=0;
 virtual HRESULT __stdcall Fy2(int)=0;
};
//Ifunctions.h End
*/
